import { config } from '../config';
import { measureStep } from './measureStep';
import { steps, addActiveSteps, removeActiveStep } from './steps';
import { getActiveStepsFromNavigationSteps, recordEndMark, recordStartMark, } from './navigationSteps';
export var measureSteps = function (mark) {
    var _a;
    if (steps.finalMarkToStepsMap[mark]) {
        recordEndMark(mark);
        // this is an end mark so we delete the entry
        var finalSteps_1 = steps.finalMarkToStepsMap[mark];
        Object.keys(finalSteps_1).forEach(function (startMark) {
            var possibleSteps = finalSteps_1[startMark];
            possibleSteps.forEach(removeActiveStep);
            Promise.all(possibleSteps.map(function (step) {
                // measure
                measureStep(step, startMark, mark);
            })).catch(function () {
                // TODO @zizzamia log error
            });
        });
    }
    else {
        recordStartMark(mark);
        addActiveSteps(mark);
    }
    var navigationBasedActiveSteps = getActiveStepsFromNavigationSteps();
    (_a = config.onMarkStep) === null || _a === void 0 ? void 0 : _a.call(config, mark, Object.keys(navigationBasedActiveSteps));
};
//# sourceMappingURL=measureSteps.js.map