"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.measureSteps = void 0;
var config_1 = require("../config");
var measureStep_1 = require("./measureStep");
var steps_1 = require("./steps");
var navigationSteps_1 = require("./navigationSteps");
var measureSteps = function (mark) {
    var _a;
    if (steps_1.steps.finalMarkToStepsMap[mark]) {
        (0, navigationSteps_1.recordEndMark)(mark);
        // this is an end mark so we delete the entry
        var finalSteps_1 = steps_1.steps.finalMarkToStepsMap[mark];
        Object.keys(finalSteps_1).forEach(function (startMark) {
            var possibleSteps = finalSteps_1[startMark];
            possibleSteps.forEach(steps_1.removeActiveStep);
            Promise.all(possibleSteps.map(function (step) {
                // measure
                (0, measureStep_1.measureStep)(step, startMark, mark);
            })).catch(function () {
                // TODO @zizzamia log error
            });
        });
    }
    else {
        (0, navigationSteps_1.recordStartMark)(mark);
        (0, steps_1.addActiveSteps)(mark);
    }
    var navigationBasedActiveSteps = (0, navigationSteps_1.getActiveStepsFromNavigationSteps)();
    (_a = config_1.config.onMarkStep) === null || _a === void 0 ? void 0 : _a.call(config_1.config, mark, Object.keys(navigationBasedActiveSteps));
};
exports.measureSteps = measureSteps;
//# sourceMappingURL=measureSteps.js.map